// Der Zoo managt die wilden Tiere und reagiert auf die Benutzereingabe.

import java.util.ArrayList;

public class Zoo {
	// Ein Array fr alle vier Tiere
	private ArrayList<Tier> alleTiere = new ArrayList<Tier> ();
	
	// Tier-Objekte erzeugen und Benutzereingabe abfragen
	public void losGehts () {
		// BenutzerEingabe-Objekt erstellen 
		Benutzereingabe eingabe = new Benutzereingabe ();
		
		// hier speichern wir die Auswahl des Benutzers
		String gewaehltesTier;
		
		// unsere vier Tiere erstellen, initialisieren und dem Zoo hinzufgen
		Affe affe = new Affe (); 
		affe.initialisieren ("Affe", "Brasilien", 5, "maennlich", "Tarzan");
		alleTiere.add (affe);
		
		Loewe loewe = new Loewe ();
		loewe.initialisieren ("Loewe", "Kenia", 13, "weiblich", "Lisa");
		alleTiere.add (loewe);

		Baer baer = new Baer();
		baer.initialisieren ("Baer", "Polen", 20, "weiblich", "Susie");
		alleTiere.add (baer);

		Hase hase = new Hase ();
		hase.initialisieren ("Hase", "Belgien", 3, "maennlich", "Hase");
		alleTiere.add (hase);
		
		
		System.out.println ("Wir haben Affen, Loewen, Baeren und Hasen.");
		System.out.println ("Um ein Tier an den Zoo zu verschenken, geben sie \"Schenken\" ein:");
		System.out.println ("Um das Programm zu beenden, geben Sie \"Ende\" ein:");
		
		// Hey, wer hat gesagt, da do-while-Schleife keinen Sinn machen?
		do {
			// Eingabe von der Tastatur speichern und in Kleinbuchstaben umwandeln
			gewaehltesTier = eingabe.getBenutzereingabe ("\nWas wollen Sie: Affe, Loewe, Baer, Hase oder Schenken oder Ende?");
			gewaehltesTier = gewaehltesTier.toLowerCase ();
			
			// ein Tier verschenken
			if (gewaehltesTier.equals ("schenken")) {
				neuzugang ();
			}

			// alle beruehrte Tiere einer Art sprechen und Geraeusche machen lassen
			for (Tier einTier : alleTiere) {
				String art = einTier.getTierart ();
				art = art.toLowerCase ();
				if (art.equals (gewaehltesTier)) {
					einTier.erzaehlWas ();
					einTier.geraeuschMachen ();
				}
			}
		
		} while (!gewaehltesTier.equals ("ende"));
		
		// am Ende alle Tiere nacheinander erzhlen lassen
		System.out.println ("\nBevor Sie gehen, melden sich alle Tiere nochmal zu Wort:");
		for (Tier einTier : alleTiere) {
			einTier.erzaehlWas ();
		}
	}
	
	
	// ein neues Tier hinzufuegen
	public void neuzugang () {
		Benutzereingabe eingabe = new Benutzereingabe();

		System.out.println ("\nDa wird sich der Zoo-Direktor aber freuen!");
		
		// Abfrage der Tiereigenschaften
		String name = eingabe.getBenutzereingabe ("Welchen Namen hat das Tier? ");
		String land = eingabe.getBenutzereingabe ("Aus welchem Land stammt das Tier? ");
		int alter = Integer.parseInt(eingabe.getBenutzereingabe ("Wie alt ist das neue Tier? "));
		String geschlecht = eingabe.getBenutzereingabe ("Welches Geschlecht hat das Tier? ");		
		String tierart = eingabe.getBenutzereingabe("Welcher Tierart gehoert das neue Tier an? ");

		// Anlegen des "richtigen" Tierobjekts entsprechend der Tierart
		if (tierart.equalsIgnoreCase ("affe")) {
			Affe affe = new Affe();
			affe.initialisieren (tierart, land, alter, geschlecht, name);
			alleTiere.add (affe);
		} else if (tierart.equalsIgnoreCase ("loewe")) {
			Loewe loewe = new Loewe();
			loewe.initialisieren (tierart, land, alter, geschlecht, name);
			alleTiere.add (loewe);
		} else if (tierart.equalsIgnoreCase ("baer")) {
			Baer baer = new Baer();
			baer.initialisieren (tierart, land, alter, geschlecht, name);
			alleTiere.add (baer);
		} else if (tierart.equalsIgnoreCase ("hase")) {
			Hase hase = new Hase();
			hase.initialisieren (tierart, land, alter, geschlecht, name);
			alleTiere.add (hase);
		} else {
			System.out.println ("\nSorry, aber diese Tierart haben wir noch nicht definiert.");
		}
	}
		
}