// Die Superklasse vererbt die gemeinsamen Instanzvariablen und Methoden fuer alle Tiere.

abstract public class Tier {
	// Instanzvariablen
	protected String tierart;
	protected String herkunftsland;
	protected int alter;
	protected String geschlecht;
	protected String name;

	// Methoden

	// ein neues Tier initialisieren
	public void initialisieren (String art, String herkunft, int jahre, String sex, String manRuftMich) {
		setTierart (art);
		setHerkunftsland (herkunft);
		setAlter (jahre);
		setGeschlecht (sex);
		setName (manRuftMich);
	}	
	
	// Infos ueber die Tiere ausgeben
	public void erzaehlWas () {
		System.out.println ("\nMein Name ist " + name + ".");		
		System.out.println ("Ich bin ein " + tierart + ".");
		System.out.println ("Ich komme aus " + herkunftsland + ".");
		System.out.println ("Mittlerweile bin ich " + alter + " Jahre jung.");
		System.out.println ("Mein Geschlecht ist " + geschlecht + ".");
	}

	// Tiere machen Gerusche
	public void geraeuschMachen () {
	}
	
	
	// Getter und Setter
	public void setTierart (String art) {
		if (art.length () != 0)
			tierart = art;
		else
			tierart = "unbekannt";
	}

	public String getTierart () {
		return tierart;
	}	
	
	public void setHerkunftsland (String herkunft) {
		if (herkunft.length () != 0)
			herkunftsland = herkunft;
		else
			herkunftsland = "unbekannt";
	}
	
	public String getHerkunftsland () {
		return herkunftsland;
	}
	
	public void setAlter (int jahre) {
		if (jahre > 0)
			alter = jahre;
		else
			alter = 0;
	}
	
	public int getAlter () {
		return alter;
	}

	public void setGeschlecht (String sex) {
		if (sex.equalsIgnoreCase ("maennlich"))
			geschlecht = "maennlich";
		else if (sex.equalsIgnoreCase ("weiblich"))
			 geschlecht = "weiblich";
		else
			 geschlecht = "unbekannt";
	}
	
	public String getGeschlecht () {
		return geschlecht;
	}	
	
	public void setName (String manNenntMich) {
		if (manNenntMich.length () != 0)
			name = manNenntMich;
		else
			name = "unbekannt";
	}
	
	public String getName () {
		return name;
	}
}